# coding=utf-8
from tornado.ioloop import IOLoop
from tornado.web import RequestHandler, Application, url, StaticFileHandler
import os
import datetime, time
import settings

# curl -X POST http://localhost:733/upload/loadtime/mydevice-myaccount/py -F "data=@file_receiver.py"

p_join = os.path.join

server_dir = os.path.abspath(os.path.split(__file__)[0])


class UploadFileHandler(RequestHandler):
    def post(self, tag, name, ext):
        self.set_header("Content-Type", "text/plain")
        file_body = self.request.files.values()[0][0]['body']

        dt = datetime.datetime.now()
        path = p_join(settings.dest_path, tag, dt.strftime('%Y.%m.%d'), name)
        if not os.path.exists(path):
            os.makedirs(path)

        t = dt.strftime('%H-%M-%S')
        report_name = report_name = '{}.{}'.format(t, ext)

        n = 1
        while os.path.exists(os.path.join(path, report_name)):
            n += 1
            report_name = '{}({}).{}'.format(t, n, ext)
        open(os.path.join(path, report_name),'wb').write(file_body)

        self.write('ok')


def make_app():
    return Application([
        url('/upload/([^/]*)/([^/]*)/([^/]*)', UploadFileHandler),
        # url(r'/robots.txt', StaticFileHandler, {'path': os.path.join(server_dir, 'static')}),
        # url(r'/static/(.*)', StaticFileHandler, {'path': os.path.join(server_dir, 'static')}),
    ])


def main():
    app = make_app()
    app.listen(settings.listen_port)
    IOLoop.current().start()

main()