
from PIL import Image, ImageDraw
import os
import sys

src_paths = sys.argv[1:]

#src_paths = [
#    r'Z:\casual11_premium_buildings\bin\tex\assets',
#    # r'Z:\casual11_premium_buildings\bin\tex\assets\premium_pig_front',
#    # r'Z:\casual11_premium_buildings\bin\tex\assets\premium_pig_iso',
#]

def is_image(filename):
    # pic_ext = [".jpg",".jpeg",".png"]
    pic_ext = [".png"]
    return os.path.splitext(filename)[1].lower() in pic_ext

w = 3
h = 5

data = range(0, w*h)


def is_alpha0((x, y)):
    return data[x + y * w][3] == 0


def not_alpha0((x, y)):
    return data[x + y * w][3] != 0


def neibours(x, y):
    # indexes = [(x-1, y-1), (x, y-1), (x+1, y-1),(x-1, y), (x+1, y),(x-1, y+1), (x, y+1), (x+1, y+1),]
    indexes = [
        (x-1, y-1), (x, y-1), (x+1, y-1),
        (x-1, y),             (x+1, y),
        (x-1, y+1), (x, y+1), (x+1, y+1),
    ]

    indexes1 = filter(lambda (x, y): (0<=x<w and 0<=y<h), indexes)
    indexes2 = filter(not_alpha0, indexes1)
    pixels = map(lambda (x,y): data[x+y*w], indexes2)
    return pixels


def mix_pixels(pixels):
    sum_alpha = sum(map(lambda p: p[3], pixels))
    chanels = [0,0,0]
    for chan in range(0,3):
        v = 0
        for p in pixels:
            v += p[chan]*p[3]
        chanels[chan] = v / sum_alpha
    return tuple(chanels) + (0,)


counter = 0
counter2 = 0

def process(dir):
    global data, w, h, counter, counter2
    files = os.listdir(dir)

    for f in files:
        fullpath = os.path.join(dir, f)
        if os.path.isdir(fullpath):
            process(fullpath)
            continue
        if not is_image(fullpath):
            continue
        if fullpath.endswith('.svin.png'):
            continue
        img = Image.open(fullpath)
        draw = ImageDraw.Draw(img)
        w = img.size[0]
        h = img.size[1]

        changed = False
        data = list(img.getdata())

        for x in xrange(0, w):
            for y in xrange(0, h):
                if not is_alpha0((x, y)):
                    continue
                if data[x+y*w]!=(255,255,255,0):
                    continue
                neibs = neibours(x, y)
                if neibs:
                    new_val = mix_pixels(neibs)
                    old_val = data[x + y * w]
                    if new_val != old_val:
                        data[x + y * w] = new_val
                        changed = True

        if changed:
            counter += 1
            print counter, fullpath, w, h
            img.putdata(data)
            img.save(fullpath, "PNG")
        else:
            counter2 += 1
            # print counter, fullpath, w, h

        #
        # rows = [data[i*img_w:(i+1)*img_w] for i in xrange(0, img_h)]
        # columns = zip(*rows)
        # r1 = 0
        # for r in rows:
        #     if all(map(lambda p: p == (255, 255, 255, 0), r)):
        #         r1 += 1
        #     else:
        #         break
        #
        # for x in xrange(0,img_w):
        #     for y in xrange(0,img_h):
        #         p = img.im.getpixel((x, y))
        #         p = p[:-1] + (255,)
        #         img.im.putpixel((x,y), p)
        # data = itertools.chain(rows)
        # img.putdata(map(lambda p: (p[:-1] + (128,)), data))
        # data = map(lambda p: (p[:-1] + (128,)), data)

        # data = map(lambda p: (p[:-1] + (255,)), data)
        # img.putdata(data)
        # img.save(fullpath+'.svin.png', "PNG")


def main():
    global counter, counter2
    for p in src_paths:
        counter = 0
        counter2 = 0
        process(p)
        print p
        print 'total: {} files'.format(counter + counter2)
        print 'fixed: {} files'.format(counter)

main()
